Index: objects/clipping.c
===================================================================
RCS file: /home/wine/wine/objects/clipping.c,v
retrieving revision 1.28
diff -u -w -r1.28 clipping.c
--- objects/clipping.c	2001/09/11 00:32:34	1.28
+++ objects/clipping.c	2001/10/26 05:21:31
@@ -124,12 +124,20 @@
     if (!hrgn) return ERROR;
     if (!(dc = DC_GetDCPtr( hdc ))) return ERROR;
 
-    TRACE("%04x %04x\n", hdc, hrgn );
+    TRACE("%04x %04x %04x\n", hdc, hrgn, dc->hVisRgn);
 
+    if( hrgn != dc->hVisRgn )
+    {
     dc->flags &= ~DC_DIRTY;
 
     retval = CombineRgn16( dc->hVisRgn, hrgn, 0, RGN_COPY );
     CLIPPING_UpdateGCRegion( dc );
+    }
+    else
+    {
+        REGION_IncRefCount(dc->hVisRgn);
+        retval = ERROR;
+    }
     GDI_ReleaseObj( hdc );
     return retval;
 }
Index: objects/gdiobj.c
===================================================================
RCS file: /home/wine/wine/objects/gdiobj.c,v
retrieving revision 1.60
diff -u -w -r1.60 gdiobj.c
--- objects/gdiobj.c	2001/09/20 19:32:39	1.60
+++ objects/gdiobj.c	2001/10/26 05:21:32
@@ -160,6 +160,16 @@
     }
 }
 
+BOOL REGION_IncRefCount(HRGN hRegion)
+{
+    GDIOBJHDR *hObj = GDI_GetObjPtr( hRegion, REGION_MAGIC);
+    if(hObj)
+    {
+        hObj->dwCount++;
+        GDI_ReleaseObj( hRegion );
+    }
+    return hObj?TRUE:FALSE;
+}
 
 /***********************************************************************
  *           dec_ref_count
Index: include/region.h
===================================================================
RCS file: /home/wine/wine/include/region.h,v
retrieving revision 1.6
diff -u -w -r1.6 region.h
--- include/region.h	2000/03/24 21:13:57	1.6
+++ include/region.h	2001/10/26 05:21:32
@@ -31,6 +31,7 @@
 extern HRGN REGION_CropRgn( HRGN hDst, HRGN hSrc, const RECT *lpRect, const POINT *lpPt );
 extern BOOL REGION_FrameRgn( HRGN dest, HRGN src, INT x, INT y );
 extern BOOL REGION_LPTODP( HDC hdc, HRGN hDest, HRGN hSrc );
+extern BOOL REGION_IncRefCount(HRGN hRegion);
 
 #endif  /* __WINE_REGION_H */
 
